<?php
// Objet gérant la connxion à la base de donnée
class DBHandle {
  // Objet PDO de Connexion
  private $db_handle;
  // Objet gérant la requête préparé sur la liste des produits
  private $req;

  // Constructeur avec des valeurs par défaut
  function __construct($serveur="localhost", $db="MVCMarket", $login="root", $password="") {
    // Ouverture de la connexion à PDO.
    $this->db_handle = new PDO("mysql:host=$serveur;dbname=$db", $login, $password);
    // Préparation de la requête (il n'y a pas besoin de bindings).
    $this->req['liste'] = $this->db_handle->prepare('SELECT * FROM produits');
    $this->req['login'] = $this->db_handle->prepare('SELECT * FROM utilisateurs WHERE login= :login');
  } 

  // Méthode exécutant la requête préparée sur la liste des produits.
  // Cette méthode construit un tableau d'objet de classe produit.
  function recupereDonneesProduits(){
    $this->req['liste']->execute();
    $res = array();
    while( $prod = $this->req['liste']->fetchObject('Produit')){
      $res[$prod->getID()]= $prod;
    }
    return $res;
  }
  // Méthode exécutant la requête préparée sur la table des utilisateurs.
  // Cette méthode répond avec un objet Utilisateur.
  function authentification($login, $password){
    $this->req['login']->bindValue(":login", $login);
    $this->req['login']->execute();
    $utilisateur = $this->req['login']->fetchObject('Utilisateur');
    if(($utilisateur != null) && ($utilisateur->isGoodPassword($password))){
      return $utilisateur;
    }
    return false;
  }
}

?>
