<?php
// La classe Produit renferme les champs correspondant à la base de donnée.
class Panier
{
  private $model = array();
  private $listeProduits;
  private $vues = array();

  public function setListeProduit($list){
    // On mémorise la liste Des Produits
    $this->listeProduits = $list;
    // On cosntruit les vues possibles du Panier
    $this->vues[]=new VueListePanier();
    $this->vues[0]->setPanier($this);
    $this->vues[]=new VueTablePanier();
    $this->vues[1]->setPanier($this);
  }
  // Cette méthode ajoute un produit à la liste
  public function add($id,$qt){
    $this->model[$id]+=$qt;
    $this->nb+=$qt;
    $produit = $this->listeProduits->getProduitByID($id);
    $this->total += $this->model[$id]*$produit->getPrix();
  }
  public function affiche($v){
    $this->vues[$v]->affiche($this->model);
  }
  public function afficheMini(){
    echo "<a href=\"index.php?action=panier\">Votre panier</a> ";
    if($this->nb>0){
      $nb = $this->totalArticle();
      echo "contient $nb article".(($nb>1)?"s":"");
      echo " pour un montant de ".$this->sommeTotale()."&euro;";
    }
    else{
      echo "est vide.";
    }
  }
  // on ne serialise pas la liste des produits et les vues dans la session ! 
  public function __sleep(){
    $res = array();
    $res[] = "model";
    return $res;
  }
  public function getListe(){
    return $this->listeProduits;
  }
  public function totalArticle(){
    $res = 0;
    foreach($this->model as $qt){
      $res+=$qt;
    }
    return $res;
  }
  public function sommeTotale(){
    $res = 0;
    foreach($this->model as $prod => $qt){
      $produit = $this->listeProduits->getProduitByID($prod);
      $res+=$qt*$produit->getPrix();
    }
    return $res;
  }
  public function removeProductByID($id){
    $this->nb -= $this->model[$id];
    unset($this->model[$id]);
  }
}
?>
